//+------------------------------------------------------------------+
//|                                                 EA Alexandru.mq4 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

string NameEA="EA Alex";

enum ENUM_LOT{
   LOT_FIXED, //Fixed
   LOT_PERC   //% Account Equify
};
enum ENUM_SOUNDS{
   SOUND_ALERT,      //alert.wav
   SOUND_ALERT2,     //alert2.wav
   SOUND_CONNECT,    //connect.wav
   SOUND_DISCONNECT, //disconnect.wav
   SOUND_EXPERT,     //expert.wav
   SOUND_NEWS,       //news.wav
   SOUND_OK,         //ok.wav
   SOUND_STOPS,      //stops.wav
   SOUND_TICK,       //tick.wav
   SOUND_TIMEOUT,    //timeout.wav
   SOUND_WAIT,       //wait.wav
};

input string            Note1                = "<---- Technical TRADING ---->";//<--------------------->
input ENUM_LOT          LotType              = LOT_FIXED;   //Lot type
input double            Lots                 = 0;           //Lot size
input int               MaxSpread            = 50;          //MaxSpread
input ENUM_TIMEFRAMES   Timeframe            = PERIOD_M30;  //Timeframe
input int               Stoploss             = 100;         //Stoploss (0 disabled)
input int               PushNotifications    = 6;           //PushNotifications (every X hours)
input int               Magic                = 12345;       //Magic Number

input string            NotePanel            = "<---- Panel settings ---->";     //<--------------------->
input bool              PanelShow            = true;        //Show Panel on the chart
input int               FontSize             = 10;          //Font size
input color             PanelColor           = clrWhite;    //Panel color
input color             TextColor            = clrDimGray;  //Text color
input int               Xdist                = 25;          //X-distance
input int               Ydist                = 25;          //Y-distance

input string            NoteMess    = "<---- A L E R T S ---->";     //<--------------------->
input bool              Alert_chart = true;                          //Show alerts on Chart
input bool              Alert_email = true;                          //Send message to E-mail
input bool              Alert_push  = true;                          //Send message to Phone
input bool              Alert_sound = true;                          //Play sound
input ENUM_SOUNDS       Sound       = SOUND_ALERT;                   //Sound Alert

input string            Note2       = "<---- Score TRADING ---->";//<--------------------->
input int               MinValOpen  = 70; //Minimum Open value 

input string            Note3          = "<---- Advanced Parameters ---->";//<--------------------->

input int               BBUpBuyAdd     = 5;     //Bollinger Bands add to BUY if bought
input int               BBUpSellAdd    = 0;     //Bollinger Bands add to SELL if bought
input int               BBDnBuyAdd     = 0;     //Bollinger Bands add to BUY if sold
input int               BBDnSellAdd    = 5;     //Bollinger Bands add to SELL if sold

input int               StochUpBuyAdd  = 30;    //Stochastic add to BUY if oversold
input int               StochUpSellAdd = -10;   //Stochastic add to SELL if oversold
input int               StochDnBuyAdd  = -10;   //Stochastic add to BUY if overbought
input int               StochDnSellAdd = 30;    //Stochastic add to SELL if overbought

input int               RMDnBuyAdd     = 5;     //Rainbow Moving add to BUY if sold
input int               RMDnSellAdd    = 5;     //Rainbow Moving add to SELL if sold
input int               RMUpBuyAdd     = 5;     //Rainbow Moving add to BUY if bought
input int               RMUpSellAdd    = 5;     //Rainbow Moving add to SELL if bought

input int               STDnBuyAdd     = 0;     //Super trend-Signals add to BUY if sold
input int               STDnSellAdd    = 10;    //Super trend-Signals add to SELL if sold
input int               STUpBuyAdd     = 10;    //Super trend-Signals add to BUY if bought
input int               STUpSellAdd    = 0;     //Super trend-Signals add to SELL if bought

input int               TCDnBuyAdd     = 0;     //Trend Continuation add to BUY if sold
input int               TCDnSellAdd    = 20;    //Trend Continuation add to SELL if sold
input int               TCUpBuyAdd     = 20;    //Trend Continuation add to BUY if bought
input int               TCUpSellAdd    = 0;     //Trend Continuation add to SELL if bought

input int               LBUpBuyAdd     = 5;     //3 Line Break add to BUY if bought
input int               LBUpSellAdd    = 0;     //3 Line Break add to SELL if bought
input int               LBDnBuyAdd     = 0;     //3 Line Break add to BUY if sold
input int               LBDnSellAdd    = 5;     //3 Line Break add to SELL if sold

input int               CIUpBuyAdd     = 20;    //Cycle  Identifier add to BUY if bought
input int               CIUpSellAdd    = 0;     //Cycle  Identifier add to SELL if bought
input int               CIDnBuyAdd     = 0;     //Cycle  Identifier add to BUY if sold
input int               CIDnSellAdd    = 20;    //Cycle  Identifier add to SELL if sold

input int               ZZAdd3level    = 30;    //ZZ Semafor Points rewarded Level 3
input int               ZZAdd2level    = 25;    //ZZ Semafor Points rewarded Level 2
input int               ZZAdd1level    = 15;    //ZZ Semafor Points rewarded Level 1

input int               SRAdd          = 20;    //Supply and Demand Points Rewarded

input string            NoteP    = "<---- P A I R S ---->";     //<--------------------->
//input string            Prefix   = "";     //Symbol Prefix
//input string            Suffix   = "";     //Symbol Suffix

input bool              AUDJPY   = true;   //AUDJPY
input bool              AUDJPYb  = true;   //Allow AUDJPY buy
input bool              AUDJPYs  = true;   //Allow AUDJPY sell

input bool              AUDNZD   = true;   //AUDNZD
input bool              AUDNZDb  = true;   //Allow AUDNZD buy
input bool              AUDNZDs  = true;   //Allow AUDNZD sell

input bool              AUDUSD   = true;   //AUDUSD
input bool              AUDUSDb  = true;   //Allow AUDUSD buy
input bool              AUDUSDs  = true;   //Allow AUDUSD sell

input bool              CADCHF   = true;   //CADCHF
input bool              CADCHFb  = true;   //Allow CADCHF buy
input bool              CADCHFs  = true;   //Allow CADCHF sell

input bool              CADJPY   = true;   //CADJPY
input bool              CADJPYb  = true;   //Allow CADJPY buy
input bool              CADJPYs  = true;   //Allow CADJPY sell

input bool              CHFJPY   = true;   //CHFJPY
input bool              CHFJPYb  = true;   //Allow CHFJPY buy
input bool              CHFJPYs  = true;   //Allow CHFJPY sell

input bool              EURAUD   = true;   //EURAUD
input bool              EURAUDb  = true;   //Allow EURAUD buy
input bool              EURAUDs  = true;   //Allow EURAUD sell

input bool              EURCAD   = true;   //EURCAD
input bool              EURCADb  = true;   //Allow EURCAD buy
input bool              EURCADs  = true;   //Allow EURCAD sell

input bool              EURCHF   = true;   //EURCHF
input bool              EURCHFb  = true;   //Allow EURCHF buy
input bool              EURCHFs  = true;   //Allow EURCHF sell

input bool              EURGBP   = true;   //EURGBP
input bool              EURGBPb  = true;   //Allow EURGBP buy
input bool              EURGBPs  = true;   //Allow EURGBP sell

input bool              EURJPY   = true;   //EURJPY
input bool              EURJPYb  = true;   //Allow EURJPY buy
input bool              EURJPYs  = true;   //Allow EURJPY sell

input bool              EURNZD   = true;   //EURNZD
input bool              EURNZDb  = true;   //Allow EURNZD buy
input bool              EURNZDs  = true;   //Allow EURNZD sell

input bool              EURUSD   = true;   //EURUSD
input bool              EURUSDb  = true;   //Allow EURUSD buy
input bool              EURUSDs  = true;   //Allow EURUSD sell

input bool              GBPAUD   = true;   //GBPAUD
input bool              GBPAUDb  = true;   //Allow GBPAUD buy
input bool              GBPAUDs  = true;   //Allow GBPAUD sell

input bool              GBPCAD   = true;   //GBPCAD
input bool              GBPCADb  = true;   //Allow GBPCAD buy
input bool              GBPCADs  = true;   //Allow GBPCAD sell

input bool              GBPUSD   = true;   //GBPUSD
input bool              GBPUSDb  = true;   //Allow GBPUSD buy
input bool              GBPUSDs  = true;   //Allow GBPUSD sell

input bool              NZDJPY   = true;   //NZDJPY
input bool              NZDJPYb  = true;   //Allow NZDJPY buy
input bool              NZDJPYs  = true;   //Allow NZDJPY sell

input bool              NZDUSD   = true;   //NZDUSD
input bool              NZDUSDb  = true;   //Allow NZDUSD buy
input bool              NZDUSDs  = true;   //Allow NZDUSD sell

input bool              USDCAD   = true;   //USDCAD
input bool              USDCADb  = true;   //Allow USDCAD buy
input bool              USDCADs  = true;   //Allow USDCAD sell

input bool              USDCHF   = true;   //USDCHF
input bool              USDCHFb  = true;   //Allow USDCHF buy
input bool              USDCHFs  = true;   //Allow USDCHF sell

input bool              USDJPY   = true;   //USDJPY
input bool              USDJPYb  = true;   //Allow USDJPY buy
input bool              USDJPYs  = true;   //Allow USDJPY sell

string               NoteBB         = "<---- Bollinger Bands ---->";   //<--------------------->
bool                 BB_use         = true;        //USE Bollinger Bands
int                  BB_Period      = 20;          //Period
double               BB_Deviation   = 2;           //Deviation
int                  BB_Shift       = 0;           //Shift
ENUM_APPLIED_PRICE   BB_Apply       = PRICE_CLOSE; //Apply to

string   NoteZZ         = "<---- 3_Level_ZZ_Semafor ---->";   //<--------------------->
bool     ZZ_use         = true;     //USE 3_Level_ZZ_Semafor
int      ZZ_Period1     = 5;        //Period1
int      ZZ_Period2     = 13;       //Period2
int      ZZ_Period3     = 34;       //Period3
string   ZZ_Dev_Step_1  = "1,3";    //Dev_Step_1
string   ZZ_Dev_Step_2  = "8,5";    //Dev_Step_2
string   ZZ_Dev_Step_3  = "21,12";  //Dev_Step_3

string   NoteCI                  = "<---- Cycle-identifier ---->";   //<--------------------->
bool     CI_use                  = true;  //USE Cycle-identifier
int      CI_PriceActionFilter    = 1;     //PriceActionFilter
int      CI_Length               = 3;     //Length
int      CI_MajorCycleStrength   = 4;     //MajorCycleStrength
bool     CI_UseCycleFilter       = false; //UseCycleFilter
int      CI_UseFilterSMAorRSI    = 1;     //UseFilterSMAorRSI
int      CI_FilterStrengthSMA    = 12;    //FilterStrengthSMA
int      CI_FilterStrengthRSI    = 21;    //FilterStrengthRSI

string   NoteTC         = "<---- Trend Continuation ---->";   //<--------------------->
bool     TC_use         = true;  //USE Trend Continuation
double   TC_n           = 20;    //n
double   TC_CountBars   = 5000;  //CountBars
double   TC_t3_period   = 5;     //t3_period
double   TC_b           = 0.618; //b

string               NoteRM         = "<---- Rainbow Moving ---->";   //<--------------------->
bool                 RM_use         = true;        //USE Rainbow Moving
int                  RM_count       = 14;          //Number of MA
int                  RM_perStart    = 5;           //Period of first MA
int                  RM_step        = 3;           //Step of periods MAs
ENUM_MA_METHOD       RM_method      = MODE_SMA;    //MA method
ENUM_APPLIED_PRICE   RM_price       = PRICE_CLOSE; //Applied price

string               NoteLB         = "<---- 3 Line Break ---->";   //<--------------------->
bool                 LB_use         = true;        //USE 3 Line Break
int                  LB_bars        = 3;           //Number of last candles

string               NoteStoch      = "<---- Stochastic ---->";   //<--------------------->
bool                 Stoch_use      = true;        //USE Stochastic
int                  Stoch_K        = 5;           //K% period
int                  Stoch_D        = 3;           //D% period
int                  Stoch_Slow     = 3;           //Slowing
ENUM_STO_PRICE       Stoch_price    = STO_LOWHIGH; //Price field
ENUM_MA_METHOD       Stoch_method   = MODE_SMA;    //MA method
double               Stoch_up       = 80;          //Level high
double               Stoch_dn       = 20;          //Level low

string               NoteST                        = "<---- Super Trend ---->";   //<--------------------->
bool                 ST_use                        = true;  //USE Super Trend
int                  TrendCCI_Period               = 14;    //TrendCCI_Period
bool                 Automatic_Timeframe_setting   = false; //Automatic_Timeframe_setting
int                  M1_CCI_Period                 = 14;    //M1_CCI_Period
int                  M5_CCI_Period                 = 14;    //M5_CCI_Period
int                  M15_CCI_Period                = 14;    //M15_CCI_Period
int                  M30_CCI_Period                = 14;    //M30_CCI_Period
int                  H1_CCI_Period                 = 14;    //H1_CCI_Period
int                  H4_CCI_Period                 = 14;    //H4_CCI_Period
int                  D1_CCI_Period                 = 14;    //D1_CCI_Period
int                  W1_CCI_Period                 = 14;    //W1_CCI_Period
int                  MN_CCI_Period                 = 14;    //MN_CCI_Period

string               NoteSR                        = "<---- Support and Resistance ---->";   //<--------------------->
bool                 SR_use                        = true;  //USE Support and Resistance

struct StructSymbol{
   string symbol;
   bool trade;
   bool buy;
   bool sell;
   double profit;
   double loss;
};
StructSymbol inputs[];

string nameGV, nameGVmaxDD;
datetime lastMess;

string Prefix, Suffix;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){

   Prefix="";
   Suffix="";
   PrefSuff(Prefix,Suffix);
   EventSetMillisecondTimer(50);
   if(IsTesting()){
      ArrayResize(inputs,1);
      inputs[0].symbol=Symbol();
      inputs[0].trade=true;
      inputs[0].buy=true;
      inputs[0].sell=true;
   }
   else{
      string error=ArraySymbols();
      //if(error !=""){
      //   Alert("Symbol: ",error," does not exist !");
      //   return(INIT_FAILED);
      //}
   }
   nameGV="GVM$$$";
   nameGVmaxDD="GVDD$$$";
   ObjectsDeleteAll(0,NameEA,0,-1);
   lastMess=0;
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
   ObjectsDeleteAll(0,NameEA,0,-1);
   
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){
   if(IsTesting()){
      Trade();
      Panel();
   }
}
//+------------------------------------------------------------------+
//| Expert timer function                                            |
//+------------------------------------------------------------------+
void OnTimer(){
   if(!IsTesting()){
      Trade();
      Panel();
   }
}
//+------------------------------------------------------------------+
//| Chart Event Function                                             |
//+------------------------------------------------------------------+
void OnChartEvent(const int id, const long   &lparam, const double &dparam, const string &sparam){
   switch(id){
      case CHARTEVENT_OBJECT_CLICK:{
         EventClick(sparam);
         break;
      }
      case CHARTEVENT_OBJECT_ENDEDIT:{
         break;
      }
      case CHARTEVENT_OBJECT_DRAG:{
         break;
      }            
   }
} 
//+------------------------------------------------------------------+
//|      Event Click                                                 |
//+------------------------------------------------------------------+
void EventClick(string sparam){
   string name=NameEA+"butClose";
   if(sparam==name){
      CloseOrder("",-1,-1,-1,Magic,"");
      ObjectSetInteger(0,name,OBJPROP_STATE,false);
   }
}
//+------------------------------------------------------------------+
//| MAIN TRADING FUNCTION                                            |
//+------------------------------------------------------------------+
void Trade(){
   for(int i=0; i<ArraySize(inputs); i++){
      if(!inputs[i].trade)continue;
      datetime timeBar=iTime(inputs[i].symbol,Timeframe,0);
      if(timeBar>GlobalVariableGet(nameGV+inputs[i].symbol)){
         int pointsBuy=0;
         int pointsSell=0;
         
         static datetime lastCount=0;
         datetime timeCurr=TimeCurrent();
         if(timeCurr>lastCount+10){
            PointsCount(inputs[i].symbol,pointsBuy,pointsSell);
            lastCount=timeCurr;
         }
         
         if(pointsBuy>=MinValOpen && inputs[i].buy){
            double lot=LotCalc(inputs[i].symbol);
            int ticket=Opener(inputs[i].symbol,ORDER_TYPE_BUY,lot);     
            if(ticket>0)GlobalVariableSet(nameGV+inputs[i].symbol,(double)TimeCurrent());    
         }
         
         if(pointsSell>=MinValOpen && inputs[i].sell){
            double lot=LotCalc(inputs[i].symbol);
            int ticket=Opener(inputs[i].symbol,ORDER_TYPE_SELL,lot);     
            if(ticket>0)GlobalVariableSet(nameGV+inputs[i].symbol,(double)TimeCurrent());    
         }         
      }
      
      if(ZZSemafor(inputs[i].symbol,Timeframe,0)>0){
         if(CloseOrder(inputs[i].symbol,-1,ORDER_TYPE_SELL,-1,Magic,"")){
            //Print("All orders of ", inputs[i].symbol," SELL was closed by reversal signal of ZZ Semafor");
         }
      }
      if(ZZSemafor(inputs[i].symbol,Timeframe,0)<0){
         if(CloseOrder(inputs[i].symbol,-1,ORDER_TYPE_BUY,-1,Magic,"")){
            //Print("All orders of ", inputs[i].symbol," BUY was closed by reversal signal of ZZ Semafor");
         }
      }
   }
}
//+------------------------------------------------------------------+
//|                Initialize array of Symbols                       |
//+------------------------------------------------------------------+
string ArraySymbols(){
   ArrayResize(inputs,21);
   
   inputs[0].symbol=Prefix+"AUDJPY"+Suffix;
   inputs[1].symbol=Prefix+"AUDNZD"+Suffix;
   inputs[2].symbol=Prefix+"AUDUSD"+Suffix;
   inputs[3].symbol=Prefix+"CADCHF"+Suffix;
   inputs[4].symbol=Prefix+"CADJPY"+Suffix;
   inputs[5].symbol=Prefix+"CHFJPY"+Suffix;
   inputs[6].symbol=Prefix+"EURAUD"+Suffix;
   inputs[7].symbol=Prefix+"EURCAD"+Suffix;
   inputs[8].symbol=Prefix+"EURCHF"+Suffix;
   inputs[9].symbol=Prefix+"EURGBP"+Suffix;
   inputs[10].symbol=Prefix+"EURJPY"+Suffix;
   inputs[11].symbol=Prefix+"EURNZD"+Suffix;
   inputs[12].symbol=Prefix+"EURUSD"+Suffix;
   inputs[13].symbol=Prefix+"GBPAUD"+Suffix;
   inputs[14].symbol=Prefix+"GBPCAD"+Suffix;
   inputs[15].symbol=Prefix+"GBPUSD"+Suffix;
   inputs[16].symbol=Prefix+"NZDJPY"+Suffix;
   inputs[17].symbol=Prefix+"NZDUSD"+Suffix;
   inputs[18].symbol=Prefix+"USDCAD"+Suffix;
   inputs[19].symbol=Prefix+"USDCHF"+Suffix;
   inputs[20].symbol=Prefix+"USDJPY"+Suffix;
   
   SymbolSelect(inputs[0].symbol,true);
   SymbolSelect(inputs[1].symbol,true);
   SymbolSelect(inputs[2].symbol,true);
   SymbolSelect(inputs[3].symbol,true);
   SymbolSelect(inputs[4].symbol,true);
   SymbolSelect(inputs[5].symbol,true);
   SymbolSelect(inputs[6].symbol,true);
   SymbolSelect(inputs[7].symbol,true);
   SymbolSelect(inputs[8].symbol,true);
   SymbolSelect(inputs[9].symbol,true);
   SymbolSelect(inputs[10].symbol,true);
   SymbolSelect(inputs[11].symbol,true);
   SymbolSelect(inputs[12].symbol,true);
   SymbolSelect(inputs[13].symbol,true);
   SymbolSelect(inputs[14].symbol,true);
   SymbolSelect(inputs[15].symbol,true);
   SymbolSelect(inputs[16].symbol,true);
   SymbolSelect(inputs[17].symbol,true);
   SymbolSelect(inputs[18].symbol,true);
   SymbolSelect(inputs[19].symbol,true);
   SymbolSelect(inputs[20].symbol,true);

   inputs[0].trade=AUDJPY;
   inputs[1].trade=AUDNZD;
   inputs[2].trade=AUDUSD;
   inputs[3].trade=CADCHF;
   inputs[4].trade=CADJPY;
   inputs[5].trade=CHFJPY;
   inputs[6].trade=EURAUD;
   inputs[7].trade=EURCAD;
   inputs[8].trade=EURCHF;
   inputs[9].trade=EURGBP;
   inputs[10].trade=EURJPY;
   inputs[11].trade=EURNZD;
   inputs[12].trade=EURUSD;
   inputs[13].trade=GBPAUD;
   inputs[14].trade=GBPCAD;
   inputs[15].trade=GBPUSD;
   inputs[16].trade=NZDJPY;
   inputs[17].trade=NZDUSD;
   inputs[18].trade=USDCAD;
   inputs[19].trade=USDCHF;
   inputs[20].trade=USDJPY;
   
   inputs[0].buy=AUDJPYb;
   inputs[1].buy=AUDNZDb;
   inputs[2].buy=AUDUSDb;
   inputs[3].buy=CADCHFb;
   inputs[4].buy=CADJPYb;
   inputs[5].buy=CHFJPYb;
   inputs[6].buy=EURAUDb;
   inputs[7].buy=EURCADb;
   inputs[8].buy=EURCHFb;
   inputs[9].buy=EURGBPb;
   inputs[10].buy=EURJPYb;
   inputs[11].buy=EURNZDb;
   inputs[12].buy=EURUSDb;
   inputs[13].buy=GBPAUDb;
   inputs[14].buy=GBPCADb;
   inputs[15].buy=GBPUSDb;
   inputs[16].buy=NZDJPYb;
   inputs[17].buy=NZDUSDb;
   inputs[18].buy=USDCADb;
   inputs[19].buy=USDCHFb;
   inputs[20].buy=USDJPYb;   
   
   inputs[0].sell=AUDJPYs;
   inputs[1].sell=AUDNZDs;
   inputs[2].sell=AUDUSDs;
   inputs[3].sell=CADCHFs;
   inputs[4].sell=CADJPYs;
   inputs[5].sell=CHFJPYs;
   inputs[6].sell=EURAUDs;
   inputs[7].sell=EURCADs;
   inputs[8].sell=EURCHFs;
   inputs[9].sell=EURGBPs;
   inputs[10].sell=EURJPYs;
   inputs[11].sell=EURNZDs;
   inputs[12].sell=EURUSDs;
   inputs[13].sell=GBPAUDs;
   inputs[14].sell=GBPCADs;
   inputs[15].sell=GBPUSDs;
   inputs[16].sell=NZDJPYs;
   inputs[17].sell=NZDUSDs;
   inputs[18].sell=USDCADs;
   inputs[19].sell=USDCHFs;
   inputs[20].sell=USDJPYs;  

   return("");
}  

//+------------------------------------------------------------------+ 
//|                     3_Level_ZZ_Semafor                           | 
//+------------------------------------------------------------------+  
int ZZSemafor( string symbol,
               ENUM_TIMEFRAMES tf,
               int shiftBars){
   
   if(!ZZ_use)return(0);

   if(CountZZ(symbol, tf,ZZ_Period3,ZZ_Dev_Step_3,shiftBars+3)==ORDER_TYPE_BUY)
      return(3);
   if(CountZZ(symbol, tf,ZZ_Period3,ZZ_Dev_Step_3,shiftBars+3)==ORDER_TYPE_SELL)
      return(-3);
   
   if(CountZZ(symbol, tf,ZZ_Period2,ZZ_Dev_Step_2,shiftBars+3)==ORDER_TYPE_BUY)
      return(2);
   if(CountZZ(symbol, tf,ZZ_Period2,ZZ_Dev_Step_2,shiftBars+3)==ORDER_TYPE_SELL)
      return(-2);

   if(CountZZ(symbol, tf,ZZ_Period1,ZZ_Dev_Step_1,shiftBars+3)==ORDER_TYPE_BUY)
      return(1);
   if(CountZZ(symbol, tf,ZZ_Period1,ZZ_Dev_Step_1,shiftBars+3)==ORDER_TYPE_SELL)
      return(-1);

   return(0);
}

ENUM_ORDER_TYPE CountZZ(   string symbol,
                           ENUM_TIMEFRAMES tf,
                           int ExtDepth,
                           string Dev_Step, 
                           int shiftBars){
   
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);   
      
   int ExtDeviation=0;
   int ExtBackstep=0;
   int Mass[]; 
   int C=0;  
   if (IntFromStr(Dev_Step,C, Mass)==1){
        ExtBackstep=Mass[1];
        ExtDeviation=Mass[0];
   }     
             
   double buffBuy[],buffSell[];            
   int shift,back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh=0,lastlow=0;

   int total=2*(1+ExtBackstep+MathMax(ExtDepth,ExtDeviation));
   if(total>Bars(symbol,tf)-1)return(-1);
   ArrayResize(buffBuy,total);
   ArrayResize(buffSell,total);
   for(shift=total-1-ExtBackstep; shift>=0; shift--){
      val=iLow(symbol,tf,iLowest(symbol,tf,MODE_LOW,ExtDepth,shift));
      if(val==lastlow) val=0.0;
      else{ 
         lastlow=val; 
         if((iLow(symbol,tf,shift)-val)>(ExtDeviation*point)) val=0.0;
         else{
            for(back=1; back<=ExtBackstep; back++){
               res=buffBuy[shift+back];
               if((res!=0)&&(res>val)) buffBuy[shift+back]=0.0; 
            }
         }
      } 
        
      buffBuy[shift]=val;
      //--- high
      val=iHigh(symbol,tf,iHighest(symbol,tf,MODE_HIGH,ExtDepth,shift));
      if(val==lasthigh) val=0.0;
      else{
         lasthigh=val;
         if((val-iHigh(symbol,tf,shift))>(ExtDeviation*point)) val=0.0;
         else{
            for(back=1; back<=ExtBackstep; back++){
               res=buffSell[shift+back];
               if((res!=0)&&(res<val)) buffSell[shift+back]=0.0; 
            } 
         }
      }
      buffSell[shift]=val;
   }
   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=total-1-ExtBackstep-ExtDepth; shift>=0; shift--){
      curlow=buffBuy[shift];
      curhigh=buffSell[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0){
         if(lasthigh>0){
            if(lasthigh<curhigh) buffSell[lasthighpos]=0;
            else buffSell[shift]=0;
         }
         //---
         if(lasthigh<curhigh || lasthigh<0){
            lasthigh=curhigh;
            lasthighpos=shift;
         }
         lastlow=-1;
      }
      //----
      if(curlow!=0){
         if(lastlow>0){
            if(lastlow>curlow) buffBuy[lastlowpos]=0;
            else buffBuy[shift]=0;
         }
         //---
         if((curlow<lastlow)||(lastlow<0)){
            lastlow=curlow;
            lastlowpos=shift;
         } 
         lasthigh=-1;
      }
   }
  
   for(shift=total-1-ExtBackstep-ExtDepth; shift>=0; shift--){
      if(shift>=total-1-ExtBackstep-ExtDepth) buffBuy[shift]=0.0;
      else{
         res=buffBuy[shift];
         if(res!=0.0) buffSell[shift]=res;
      }
   }
   if(shiftBars>=ArraySize(buffBuy))return(-1);
   if(buffBuy[shiftBars] !=0)return(ORDER_TYPE_BUY);
   if(buffSell[shiftBars] !=0)return(ORDER_TYPE_SELL);
   return(-1);
}
  
int Str2Massive(string VStr, int& M_Count, int& VMass[]){
    int val=StrToInteger( VStr);
    if (val>0){
         M_Count++;
         int mc=ArrayResize(VMass,M_Count);
         if (mc==0)return(-1);
          VMass[M_Count-1]=val;
         return(1);
    }
    else return(0);    
} 
int IntFromStr(string ValStr,int& M_Count, int& VMass[]){
    
    if (StringLen(ValStr)==0) return(-1);
    string SS=ValStr;
    int NP=0; 
    string CS;
    M_Count=0;
    ArrayResize(VMass,M_Count);
    while (StringLen(SS)>0){
      NP=StringFind(SS,",");
      if (NP>0){
           CS=StringSubstr(SS,0,NP);
           SS=StringSubstr(SS,NP+1,StringLen(SS));  
      }
      else{
        if (StringLen(SS)>0){
             CS=SS;
             SS="";
        }
      }
      if (Str2Massive(CS,M_Count,VMass)==0){
           return(-2);
      }
    }
    return(1);    
}

//+------------------------------------------------------------------+ 
//|                     Cycle Identifier Indicator                   | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE CycleIdentifier( string symbol,
                                 ENUM_TIMEFRAMES tf,
                                 int shiftBars){  
   
   if(!CI_use)return(ORDER_TYPE_BUY_LIMIT);
   
   int depth=50;                            
                                 
   double LineBuffer[];
   double MajorCycleBuy[];
   double MajorCycleSell[];
   double MinorCycleBuy[];
   double MinorCycleSell[];
   double ZL1[];
   
   ArrayResize(LineBuffer,depth+1);
   ArrayResize(MajorCycleBuy,depth+1);
   ArrayResize(MajorCycleSell,depth+1);
   ArrayResize(MinorCycleBuy,depth+1);
   ArrayResize(MinorCycleSell,depth+1);
   ArrayResize(ZL1,depth+3);

   double CyclePrice=0.0, Strength =0.0, SweepA=0.0, SweepB=0.0;
   int Switch=0, Switch2=0,   SwitchA=0, SwitchB=0, SwitchC=0, SwitchD=0, SwitchE=0, SwitchAA=0, SwitchBB=0;
   double Price1BuyA=0.0, Price2BuyA=0.0;
   int Price1BuyB=1.0, Price2BuyB=1.0;
   double Price1SellA=0.0, Price2SellA=0.0;
   int Price1SellB=0.0, Price2SellB=0.0;
   bool ActiveSwitch=True, BuySwitchA=FALSE, BuySwitchB=FALSE, SellSwitchA=FALSE, SellSwitchB=FALSE;
   int BuySellFac=01;
   bool Condition1, Condition6;

   int rnglength=250;
   double range=0.0, srange=0.0;
   
   for(int pos=depth; pos>=0; pos--){
   
      srange=0.0;
      int j=0;
      for(int i=0;i<rnglength;i++){
         j++;
         int posr=pos + i;
         if (posr>=iBars(symbol,tf))
            break;
         srange=srange + (iHigh(symbol,tf,posr) - iLow(symbol,tf,posr));
      }
      range=srange/j * CI_Length;
      int BarNumber=depth-pos;
      if (BarNumber < 0) BarNumber=0;
      
      CyclePrice=iMA(symbol, tf, CI_PriceActionFilter, 0, MODE_SMMA, PRICE_CLOSE, pos);
      if (CI_UseFilterSMAorRSI==1)
         ZL1[pos]=ZeroLag(CyclePrice,CI_FilterStrengthSMA, pos, ZL1);
      if (CI_UseFilterSMAorRSI==2)
         ZL1[pos]=ZeroLag( iRSI(NULL, 0, 14, (ENUM_APPLIED_PRICE)CyclePrice, CI_FilterStrengthRSI ), CI_FilterStrengthRSI, pos, ZL1);
      if (ZL1[pos] > ZL1[pos+1])
         SwitchC=1;
      if (ZL1[pos] < ZL1[pos+1])
         SwitchC=2;
         
      if (BarNumber<=1){
         if (Strength==0) SweepA =range;
         else SweepA=Strength;
         Price1BuyA =CyclePrice;
         Price1SellA =CyclePrice;
      }
      /* ***************************************************************** */
      if (BarNumber > 1){
         if (Switch > -1){
            if (CyclePrice < Price1BuyA){
               if (CI_UseCycleFilter && (SwitchC==2) && BuySwitchA){
                  MinorCycleBuy[pos + BarNumber - Price1BuyB]=0; //MinorBuySell
                  LineBuffer[pos + BarNumber - Price1BuyB ]=0; //line
               }
               if (!CI_UseCycleFilter && BuySwitchA){
                  MinorCycleBuy[pos +BarNumber - Price1BuyB]=0;
                  LineBuffer[pos +BarNumber - Price1BuyB]=0;
               }
               Price1BuyA=CyclePrice;
               Price1BuyB=BarNumber;
               BuySwitchA=TRUE;
            }
            else if (CyclePrice > Price1BuyA){
               SwitchA=BarNumber - Price1BuyB;
               if (!CI_UseCycleFilter){
                  MinorCycleBuy[pos +SwitchA]=-1;//MinorBuySell - DarkGreen
                  LineBuffer[pos +SwitchA]=-1;//line
               }
               if (CI_UseCycleFilter && SwitchC ==1){
                  MinorCycleBuy[pos +SwitchA]=-1;  //MinorBuySell
                  LineBuffer[pos +SwitchA]=-1; //line
                  SwitchD=1;
               }
               else SwitchD=0;
   
               BuySwitchA=TRUE;
               double cyclePrice1=iMA(symbol, tf, CI_PriceActionFilter, 0, MODE_SMMA, PRICE_CLOSE, pos + SwitchA);
               if (ActiveSwitch)
                  Condition1=CyclePrice - cyclePrice1>=SweepA;
   
               else
                  Condition1=CyclePrice>=cyclePrice1 * (1 + SweepA/1000);
                 
               if (Condition1 && SwitchA>=BuySellFac){
                  Switch= - 1;
                  Price1SellA=CyclePrice;
                  Price1SellB=BarNumber;
                  SellSwitchA=FALSE;
                  BuySwitchA=FALSE;
               }
            }
         }
         if(Switch < 1){
            if (CyclePrice > Price1SellA){
               if (CI_UseCycleFilter && SwitchC==1 && SellSwitchA){
                  MinorCycleSell[pos +BarNumber - Price1SellB]=0; //MinorBuySell
                  LineBuffer[pos +BarNumber - Price1SellB ]=0; //line
               }
               if (!CI_UseCycleFilter && SellSwitchA){
                  MinorCycleSell[pos +BarNumber - Price1SellB]=0;//MinorBuySell
                  LineBuffer[pos +BarNumber - Price1SellB]=0;//line
               }
               Price1SellA=CyclePrice;
               Price1SellB=BarNumber;
               SellSwitchA=TRUE;
            }
            else if (CyclePrice < Price1SellA){
               SwitchA=BarNumber - Price1SellB;
               if (!CI_UseCycleFilter){
                  MinorCycleSell[pos +SwitchA]=1; // MinorBuySell darkRed
                  LineBuffer[pos +SwitchA]=1; //"CycleLine"
               }
               if (CI_UseCycleFilter && (SwitchC==2)){
                  MinorCycleSell[pos +SwitchA]=1;//MinorBuySell darkRed
                  LineBuffer[pos +SwitchA]=1;//CycleLine
                  SwitchD =2;
               }
               else
                  SwitchD =0;
               
               SellSwitchA=TRUE;
               double cyclePrice2=iMA(symbol, tf, CI_PriceActionFilter, 0, MODE_SMMA, PRICE_CLOSE, pos + SwitchA);
               
               if (ActiveSwitch)
                  Condition1=(cyclePrice2 - CyclePrice)>=SweepA;
               else
                  Condition1=CyclePrice<=(cyclePrice2 * (1 - SweepA/1000));
               
               if (Condition1 && SwitchA>=BuySellFac){
                  Switch=1;
                  Price1BuyA=CyclePrice;
                  Price1BuyB=BarNumber;
                  SellSwitchA=FALSE;
                  BuySwitchA=FALSE;
               }
            }
         }
      }
      LineBuffer[pos]=0;
      MinorCycleBuy[pos]=0;
      MinorCycleSell[pos]=0;
   //----
      if (BarNumber==1){
         if (Strength==0)
            SweepB =range *  CI_MajorCycleStrength;
         else
            SweepB=Strength * CI_MajorCycleStrength;
         Price2BuyA=CyclePrice;
         Price2SellA=CyclePrice;
      }
      if (BarNumber > 1){
         if (Switch2  >  - 1){
            if (CyclePrice < Price2BuyA){
               if (CI_UseCycleFilter && SwitchC==2 && BuySwitchB){
                  MajorCycleBuy [pos +BarNumber - Price2BuyB]=0; //MajorBuySell,green
               }
               if (!CI_UseCycleFilter && BuySwitchB){
                  MajorCycleBuy [pos +BarNumber - Price2BuyB]=0;//MajorBuySell,green
               }
               Price2BuyA=CyclePrice;
               Price2BuyB=BarNumber;
               BuySwitchB=TRUE;
            }
            else if (CyclePrice > Price2BuyA){
               SwitchB=BarNumber - Price2BuyB;
               if (!CI_UseCycleFilter){
                  MajorCycleBuy [pos +SwitchB]=-1; //MajorBuySell green
               }
               if (CI_UseCycleFilter && SwitchC ==1){
                  MajorCycleBuy [pos +SwitchB]=-1; //MajorBuySell green
                  SwitchE =1;
               }
               else
                  SwitchE =0;
                  
               BuySwitchB=TRUE;
               double cyclePrice3=iMA(symbol, tf, CI_PriceActionFilter, 0, MODE_SMMA, PRICE_CLOSE, pos + SwitchB);
               if (ActiveSwitch)
                  Condition6=CyclePrice - cyclePrice3>=SweepB;
               else
                  Condition6=CyclePrice>=cyclePrice3 * (1 + SweepB/1000);
               
               if (Condition6 && SwitchB>=BuySellFac){
                  Switch2= - 1;
                  Price2SellA=CyclePrice;
                  Price2SellB=BarNumber;
                  SellSwitchB=FALSE;
                  BuySwitchB=FALSE;
               }
            }
         }
         
         if (Switch2 < 1){
            if (CyclePrice > Price2SellA){
               if (CI_UseCycleFilter && SwitchC ==1 && SellSwitchB){
                  MajorCycleSell [pos +BarNumber - Price2SellB]=0; //"MajorBuySell",red 
               }
               if (!CI_UseCycleFilter && SellSwitchB){
                  MajorCycleSell [pos +BarNumber - Price2SellB]=0;//"MajorBuySell",red 
               }
               Price2SellA=CyclePrice;
               Price2SellB=BarNumber;
               SellSwitchB=TRUE;
            }
            else if (CyclePrice < Price2SellA){
               SwitchB=BarNumber - Price2SellB ;
               if (!CI_UseCycleFilter){
                  MajorCycleSell[pos + SwitchB]=1; //"MajorBuySell",red 
               }
               if (CI_UseCycleFilter && SwitchC ==2){
                  MajorCycleSell [pos + SwitchB]=1; //"MajorBuySell",red 
                  SwitchE =2;
               }
               else
                  SwitchE =0;
               SellSwitchB=TRUE;
               double cyclePrice4=iMA(symbol, tf, CI_PriceActionFilter, 0, MODE_SMMA, PRICE_CLOSE, pos + SwitchB);
               
               if (ActiveSwitch)
                  Condition6=cyclePrice4 - CyclePrice>=SweepB;
               else
                  Condition6=CyclePrice<=cyclePrice4 * (1.0 - SweepB/1000.0);
               
               if (Condition6 && SwitchB>=BuySellFac){
                  Switch2=1;
                  Price2BuyA=CyclePrice;
                  Price2BuyB=BarNumber;
                  SellSwitchB=FALSE;
                  BuySwitchB=FALSE;
               }
            }
         }
      }
      LineBuffer[pos]=0;
      MajorCycleSell[pos]=0;
      MajorCycleBuy[pos]=0;
   }

   if(LineBuffer[shiftBars]==1)return(ORDER_TYPE_SELL);
   if(LineBuffer[shiftBars]==-1)return(ORDER_TYPE_BUY);
   return(-1);
}

double ZeroLag(double price, int length, int pos, double& zl[]){
   if (length < 3) return(price);

   double aa=MathExp(-1.414*3.14159/length);
   double bb=2*aa*MathCos(1.414*180/length);
   double CB=bb;
   double CC=-aa*aa;
   double CA=1 - CB - CC;
   double CD=CA*price + CB*zl[pos+1] + CC*zl[pos+2];
   return(CD);
}
//+------------------------------------------------------------------+ 
//|                  Bollinger Bands                                 | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE BollingerBands(  string symbol,
                                 ENUM_TIMEFRAMES tf,
                                 int shift){
   
   if(!BB_use)return(ORDER_TYPE_BUY_LIMIT);
   
   double up=iBands(symbol,tf,BB_Period,BB_Deviation,BB_Shift,BB_Apply,1,shift);
   double dn=iBands(symbol,tf,BB_Period,BB_Deviation,BB_Shift,BB_Apply,2,shift);
   
   double bid=SymbolInfoDouble(symbol,SYMBOL_BID);
   
   if(bid>=up)return(ORDER_TYPE_SELL);
   if(bid<=dn)return(ORDER_TYPE_BUY);
   return(-1);
}

//+------------------------------------------------------------------+ 
//|                  Trend Continuation                              | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE TrendContinuation(  string symbol,
                                    ENUM_TIMEFRAMES tf,
                                    int shiftBars){
   int depth=100;
   
   int shift;
   double ExtHistoBuffer[];
   double ExtHistoBuffer2[];
   
   ArrayResize(ExtHistoBuffer,depth+2);
   ArrayResize(ExtHistoBuffer2,depth+2);

   int cnt=0;
   double k_n=0;
   double k_p=0;
   int shiftt=0;
   double ch_p=0;
   double ch_n=0;
   double cff_p=0;
   double cff_n=0;
   double AccountedBars=0;
   double CF_p[];
   ArrayResize(CF_p,5001);
   double CF_n[];
   ArrayResize(CF_n,5001);
   double Change_p[];
   ArrayResize(Change_p,5001);
   double Change_n[];
   ArrayResize(Change_n,5001);
   double t3=0;
   double t32=0;
   double A1=0;
   double A2=0;
   double b2=0;
   double b3=0;
   double c1=0;
   double c2=0;
   double c3=0;
   double c4=0;
   double e1=0;
   double e2=0;
   double e3=0;
   double e4=0;
   double e5=0;
   double e6=0;
   double n1=0;
   double w1=0;
   double w2=0;
   double e12=0;
   double e22=0;
   double e32=0;
   double e42=0;
   double e52=0;
   double e62=0;
//----
   b2=TC_b*TC_b;
   b3=b2*TC_b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+TC_b+b3);
   c4=(1+3*TC_b+b3+3*b2);
   n1=TC_t3_period;
   if(n1<1)n1=1;
   n1=1 + 0.5*(n1-1);
   w1=2/(n1 + 1);
   w2=1 - w1;

   int limit = depth;

   for(cnt =0; cnt <=limit ;cnt ++){
      shift=limit - cnt;
      if(iClose(symbol,tf,shift) > iClose(symbol,tf,shift+1)){ 
         Change_p[shift]=iClose(symbol,tf,shift)- iClose(symbol,tf,shift+1);
         CF_p[shift]= Change_p[shift] + CF_p[shift+1];
         Change_n[shift]=0;
         CF_n[shift]= 0;
      }
      else{ 
         Change_p[shift]=0;
         CF_p[shift]=0;
         Change_n[shift] =iClose(symbol,tf,shift+1)- iClose(symbol,tf,shift);
         CF_n[shift]=Change_n[shift]+ CF_n[shift+1];
      }
        
      for(shiftt=shift+(int)TC_n; shiftt>=shift ;shiftt--){
         ch_p=Change_p[shiftt] +ch_p;
         ch_n=Change_n[shiftt]+ch_n ;
         cff_p= CF_p[shiftt]+cff_p;
         cff_n= CF_n[shiftt]+cff_n;
      }
      k_p=ch_p-cff_n;
      k_n=ch_n-cff_p;
      A1=k_p;
      e1=w1*A1 + w2*e1;
      e2=w1*e1 + w2*e2;
      e3=w1*e2 + w2*e3;
      e4=w1*e3 + w2*e4;
      e5=w1*e4 + w2*e5;
      e6=w1*e5 + w2*e6;
      t3=c1*e6 + c2*e5 + c3*e4 + c4*e3;
      ExtHistoBuffer[shift]=t3;
      A2=k_n;
      e12=w1*A2 + w2*e12;
      e22=w1*e12 + w2*e22;
      e32=w1*e22 + w2*e32;
      e42=w1*e32 + w2*e42;
      e52=w1*e42 + w2*e52;
      e62=w1*e52 + w2*e62;
      t32=c1*e62 + c2*e52 + c3*e42 + c4*e32;
      ExtHistoBuffer2[shift]=t32;
      AccountedBars=AccountedBars+1;
      ch_p=0;
      ch_n=0;
      cff_p=0;
      cff_n=0;
   }
   if(ExtHistoBuffer[shiftBars]>ExtHistoBuffer2[shiftBars])return(ORDER_TYPE_BUY);
   if(ExtHistoBuffer[shiftBars]<ExtHistoBuffer2[shiftBars])return(ORDER_TYPE_SELL);
   
   return(-1);
}
//+------------------------------------------------------------------+ 
//|                  Rainbow Moving                                  | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE RainbowMoving(   string symbol,
                                 ENUM_TIMEFRAMES tf,
                                 int shiftBars){
   
   if(!RM_use)return(ORDER_TYPE_BUY_LIMIT);

   double arr[][10];
   int depth=ArrayRange(arr,1);
   
   ArrayResize(arr,RM_count);
   
   for(int i=0; i<RM_count; i++){
      for(int k=0; k<depth; k++){
         arr[i][k]=iMA(symbol,tf,RM_perStart+RM_step*i,0,RM_method,RM_price,k);
      }
   }
   
   int countBuy=0;
   int countSell=0;
   for(int i=0; i<RM_count; i++){
      for(int k=0; k<depth-1; k++){
         if(arr[i][k]>arr[i][k+1])countBuy++;
         if(arr[i][k]<arr[i][k+1])countSell++;
      }
   }   
   if(countBuy>0 && countSell==0)return(ORDER_TYPE_BUY);
   if(countBuy==0 && countSell>0)return(ORDER_TYPE_SELL);
   return(-1);
}
//+------------------------------------------------------------------+ 
//|                  3 Line Break                                    | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE LineBreak( string symbol,
                           ENUM_TIMEFRAMES tf,
                           int shiftBars){
   
   if(!LB_use)return(ORDER_TYPE_BUY_LIMIT);
   
   double low=iLow(symbol,tf,iLowest(symbol,tf,MODE_LOW,LB_bars,shiftBars+1));
   double high=iHigh(symbol,tf,iHighest(symbol,tf,MODE_HIGH,LB_bars,shiftBars+1));
   
   double close=iClose(symbol,tf,shiftBars);
   
   if(close>high)return(ORDER_TYPE_BUY);
   if(close>low)return(ORDER_TYPE_SELL);

   return(-1);
}
//+------------------------------------------------------------------+ 
//|                  Stochastic                                      | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE Stochastic(string symbol,
                           ENUM_TIMEFRAMES tf,
                           int shiftBars){
   
   if(!Stoch_use)return(ORDER_TYPE_BUY_LIMIT);
   
   double stoch=iStochastic(symbol,tf,Stoch_K,Stoch_D,Stoch_Slow,Stoch_method,Stoch_price,0,shiftBars);

   if(stoch>=Stoch_up)return(ORDER_TYPE_SELL);
   if(stoch<=Stoch_dn)return(ORDER_TYPE_BUY);
   
   return(-1);
}

//+------------------------------------------------------------------+ 
//|                  Super Trend                                     | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE SuperTrend(string symbol,
                           ENUM_TIMEFRAMES tf,
                           int shiftBars){
                           
   if(!ST_use)return(ORDER_TYPE_BUY_LIMIT);

   if(tf==0)tf=(ENUM_TIMEFRAMES)(PeriodSeconds()/60);
   int depth=50+shiftBars;

   double TrendUp[];
   double TrendDown[];
   double NonTrend[];
   
   ArrayResize(TrendUp,depth+1);
   ArrayResize(TrendDown,depth+1);
   ArrayResize(NonTrend,depth+1);
   
   int st = 0;
   
   int UpDownShift=0;
   
   switch(tf) {
      case 1:     UpDownShift = 3; break;
      case 5:     UpDownShift = 5; break;
      case 15:    UpDownShift = 7; break;
      case 30:    UpDownShift = 9; break;
      case 60:    UpDownShift = 20; break;
      case 240:   UpDownShift = 35; break;
      case 1440:  UpDownShift = 40; break;
      case 10080: UpDownShift = 100; break;
      case 43200: UpDownShift = 120; break;
   }   
   
   int limit, i, cciPeriod=0;
   double cciTrendNow, cciTrendPrevious;

   limit=depth;
   
   if (Automatic_Timeframe_setting == true) {
      switch(tf) {
         case 1:     cciPeriod = M1_CCI_Period; break;
         case 5:     cciPeriod = M5_CCI_Period; break;
         case 15:    cciPeriod = M15_CCI_Period; break;
         case 30:    cciPeriod = M30_CCI_Period; break;
         case 60:    cciPeriod = H1_CCI_Period; break;
         case 240:   cciPeriod = H4_CCI_Period; break;
         case 1440:  cciPeriod = D1_CCI_Period; break;
         case 10080: cciPeriod = W1_CCI_Period; break;
         case 43200: cciPeriod = MN_CCI_Period; break;
      }
   }
   else {   
      cciPeriod = TrendCCI_Period;
   }
   
   for(i = limit-1; i >= 0; i--) {
   
      cciTrendNow = iCCI(symbol, tf, cciPeriod, PRICE_TYPICAL, i) + 70;
      cciTrendPrevious = iCCI(symbol, tf, cciPeriod, PRICE_TYPICAL, i+1) + 70;
      
      if (cciTrendNow > st && cciTrendPrevious < st) {
         TrendUp[i+1] = TrendDown[i+1];
      }
      
      if (cciTrendNow < st && cciTrendPrevious > st) {
         TrendDown[i+1] = TrendUp[i+1];
      }
      
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      if (cciTrendNow > 0) {
         TrendUp[i] = iLow(symbol,tf,i) - point*(double)UpDownShift;
         TrendDown[i] = EMPTY_VALUE;
         if (iClose(symbol,tf,i) < iOpen(symbol,tf,i) && TrendDown[i+1] != TrendUp[i+1]) {
            TrendUp[i] = TrendUp[i+1];
         }        
         if (TrendUp[i] < TrendUp[i+1] && TrendDown[i+1] != TrendUp[i+1]) {
            TrendUp[i] = TrendUp[i+1];
         }
         if (iHigh(symbol,tf,i) < iHigh(symbol,tf,i+1) && TrendDown[i+1] != TrendUp[i+1]) {
            TrendUp[i] = TrendUp[i+1];
         }
      }
      else if (cciTrendNow < 0) {
         TrendDown[i] = iHigh(symbol,tf,i) + point*(double)UpDownShift;
         TrendUp[i] = EMPTY_VALUE;
         if (iClose(symbol,tf,i) > iOpen(symbol,tf,i) && TrendDown[i+1] != TrendUp[i+1]) {
            TrendDown[i] = TrendDown[i+1];
         }
         if (TrendDown[i] > TrendDown[i+1] && TrendDown[i+1] != TrendUp[i+1]) {
            TrendDown[i] = TrendDown[i+1];
         }
         if (iLow(symbol,tf,i) > iLow(symbol,tf,i+1) && TrendUp[i+1] != TrendDown[i+1]) {
            TrendDown[i] = TrendDown[i+1];
         }
      }
   }   
   
   if(TrendUp[shiftBars]!=EMPTY_VALUE)return(ORDER_TYPE_BUY);
   if(TrendDown[shiftBars]!=EMPTY_VALUE)return(ORDER_TYPE_SELL);
   
   return(-1);
}

//+------------------------------------------------------------------+ 
//|                  Support and Resistance levels                   | 
//+------------------------------------------------------------------+  
ENUM_ORDER_TYPE SuppResist(string symbol,
                           ENUM_TIMEFRAMES tf,
                           int shiftBars){
   
   if(!SR_use)return(ORDER_TYPE_BUY_LIMIT);

   double supp=FindSuppResist(symbol,tf,1,true);
   double resist=FindSuppResist(symbol,tf,1,false);
   
   if(iHigh(symbol,tf,0)>=resist)return(ORDER_TYPE_SELL);
   if(iLow(symbol,tf,0)<=supp)return(ORDER_TYPE_BUY);

   double suppBreak=FindSuppResist(symbol,tf,5,true);
   int countSupp=0;
   
   for(int i=4; i>0; i--){
      if(iClose(symbol,tf,i)<suppBreak)countSupp++;
   }
   if(countSupp>=4)return(ORDER_TYPE_SELL);
   
   
   double resistBreak=FindSuppResist(symbol,tf,5,false);
   int countResist=0;
   
   for(int i=4; i>0; i--){
      if(iClose(symbol,tf,i)>resistBreak)countResist++;
   }   
   if(countSupp>=4)return(ORDER_TYPE_BUY);
   
   return(-1);
}

double FindSuppResist(string symbol,
                      ENUM_TIMEFRAMES tf,
                      int shiftBars,
                      bool support){

   int buff=2;
   if(!support)buff=1;
   int i=shiftBars;
   while(i<iBars(symbol,tf)-1){
      double fract=iFractals(symbol,tf,buff,i);
      if(fract>0)return(fract);
      i++;
   }
   return(-1);
}
//--------------------------------------------------------------------+
//        Send Notification (Chart, E-mail, Phone, Sound)             |
//--------------------------------------------------------------------+
void Messenger(string   text        , 
               bool     alert_chart ,
               bool     alert_email ,
               bool     alert_push  ,
               bool     alert_sound ,
               string   sound){

   if(alert_chart)Alert(text);
   if(alert_sound)PlaySound(sound);
   
   int NumberAttempts=5;

   int counterPhone=0;
   int counterEmail=0;
   int numberAttempt=0;
   datetime Timer=0;
   bool SetTimer=true;
   bool sendMessageToPhone=false;
   bool sendMessageToEmail=false;
   if(alert_push)sendMessageToPhone=true;
   if(alert_email)sendMessageToEmail=true;
   
   bool FirstAttempt=true;
   bool NextAttemptPhone=false;
   bool NextAttemptEmail=false;   
   
   while((sendMessageToEmail || sendMessageToPhone) && 
         (counterPhone<=numberAttempt || counterEmail<=numberAttempt)){
      if(SetTimer){
         Timer=TimeCurrent();
         SetTimer=false;
      }
      if(FirstAttempt){
         if(alert_push)
            if(!SendMessagePhone(text))NextAttemptPhone=true;
         
         if(alert_email)
            if(!SendMessageEmail(text))NextAttemptEmail=true;
         FirstAttempt=false;
         counterPhone++;
         counterEmail++;
      }
      if(NextAttemptEmail){
         if(!SendMessageEmail(text))SetTimer=true;
         else{
            NextAttemptEmail=false;
            sendMessageToEmail=false;
         }
         counterEmail++; 
      }
      if(NextAttemptPhone && TimeCurrent()-Timer>=7){
         if(!SendMessagePhone(text))SetTimer=true;
         else{
            NextAttemptPhone=false;
            sendMessageToPhone=false;
         }
         counterPhone++;         
      }
      if(counterEmail>=NumberAttempts)sendMessageToEmail=false;
      if(counterPhone>=NumberAttempts)sendMessageToPhone=false;
   }
}
//+------------------------------------------------------------------+
//|              Send Message Phone                                  |
//+------------------------------------------------------------------+
bool SendMessagePhone(string text){
   if(!IsTesting()){
      ResetLastError();
      if(!SendNotification(text)){
         Print(__FUNCTION__," ",GetLastError());
         return(false);
      }
   }
   return(true);
}
//+------------------------------------------------------------------+
//|              Send Message E-mail                                 |
//+------------------------------------------------------------------+
bool SendMessageEmail(string text){
   if(!IsTesting()){
      ResetLastError();
      if(!SendMail(text,text)){
         Print(__FUNCTION__," ",GetLastError());
         return(false);
      }
   }
   return(true);
}
//--------------------------------------------------------------------+
//      Lot Calculate                                                 |
//--------------------------------------------------------------------+
double LotCalc(string symbol){ 

   double lot=0;
   if(LotType==LOT_FIXED)lot=Lots;
   
   if(LotType==LOT_PERC && Lots>0){
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      double pointValue=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE)*
                        (point/SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE));
   
      lot=(AccountInfoDouble(ACCOUNT_EQUITY)*Lots/100)/(pointValue*Stoploss);
   }
   double minLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
   double maxLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);
   double lotStep=SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
   lot=MathRound(lot/lotStep)*lotStep;
   if(lot<minLot && lot>0)lot=minLot;
   if(lot>maxLot && lot>0)lot=maxLot;   
   
   return(lot);
}

//--------------------------------------------------------------------+
//      Count points                                                  |
//--------------------------------------------------------------------+
void PointsCount( string symbol,
                  int& pointsBuy,
                  int& pointsSell){

   ENUM_ORDER_TYPE bollinger = BollingerBands(symbol,Timeframe,0);
   ENUM_ORDER_TYPE rainbow = RainbowMoving(symbol,Timeframe,0);
   ENUM_ORDER_TYPE lineBreak = LineBreak(symbol,Timeframe,0);
   ENUM_ORDER_TYPE cycleIdent = CycleIdentifier(symbol,Timeframe,0);
   ENUM_ORDER_TYPE stoch = Stochastic(symbol,Timeframe,1);
   ENUM_ORDER_TYPE trendCont = TrendContinuation(symbol,Timeframe,0);
   ENUM_ORDER_TYPE superTrend = SuperTrend(symbol,Timeframe,1);
   ENUM_ORDER_TYPE sr = SuppResist(symbol,Timeframe,1);
   int zz=ZZSemafor(symbol,Timeframe,3);
   
   if(bollinger==ORDER_TYPE_BUY){
      pointsBuy+=BBUpBuyAdd;
      pointsSell+=BBUpSellAdd;
   }
   if(bollinger==ORDER_TYPE_SELL){
      pointsBuy+=BBDnBuyAdd;
      pointsSell+=BBDnSellAdd;
   }
   
   if(rainbow==ORDER_TYPE_BUY){
      pointsBuy+=RMUpBuyAdd;
      pointsSell+=RMUpSellAdd;
   }
   if(rainbow==ORDER_TYPE_SELL){
      pointsBuy+=RMDnBuyAdd;
      pointsSell+=RMDnSellAdd;
   }   
   
   if(lineBreak==ORDER_TYPE_BUY){
      pointsBuy+=LBUpBuyAdd;
      pointsSell+=LBUpSellAdd;
   }
   if(lineBreak==ORDER_TYPE_SELL){
      pointsBuy+=LBDnBuyAdd;
      pointsSell+=LBDnSellAdd;
   }  
   
   if(cycleIdent==ORDER_TYPE_BUY){
      pointsBuy+=CIUpBuyAdd;
      pointsSell+=CIUpSellAdd;
   }
   if(cycleIdent==ORDER_TYPE_SELL){
      pointsBuy+=CIDnBuyAdd;
      pointsSell+=CIDnSellAdd;
   }     
   
   if(stoch==ORDER_TYPE_BUY){
      pointsBuy+=StochUpBuyAdd;
      pointsSell+=StochUpSellAdd;
   }
   if(stoch==ORDER_TYPE_SELL){
      pointsBuy+=StochDnBuyAdd;
      pointsSell+=StochDnSellAdd;
   } 
   
   if(trendCont==ORDER_TYPE_BUY){
      pointsBuy+=TCUpBuyAdd;
      pointsSell+=TCUpSellAdd;
   }
   if(trendCont==ORDER_TYPE_SELL){
      pointsBuy+=TCDnBuyAdd;
      pointsSell+=TCDnSellAdd;
   }  
   
   if(superTrend==ORDER_TYPE_BUY){
      pointsBuy+=STUpBuyAdd;
      pointsSell+=STUpSellAdd;
   }
   if(superTrend==ORDER_TYPE_SELL){
      pointsBuy+=STDnBuyAdd;
      pointsSell+=STDnSellAdd;
   }   
   
   if(zz==3) pointsBuy+=ZZAdd3level;
   if(zz==2) pointsBuy+=ZZAdd2level;
   if(zz==1) pointsBuy+=ZZAdd1level;
   
   if(zz==-3) pointsSell+=ZZAdd3level;
   if(zz==-2) pointsSell+=ZZAdd2level;
   if(zz==-1) pointsSell+=ZZAdd1level;
}

//--------------------------------------------------------------------+
//      Open Orders (standart function for opening orders)            |
//--------------------------------------------------------------------+
enum ENUM_TYPE_STOPS{POINTS, LEVEL, PERCENT_STOP};
datetime timerTradeAllowed=0;

int  Opener(string            symbol, 
            ENUM_ORDER_TYPE   type,
            double            lot){
   
   double            priceOpen=0;
   ENUM_TYPE_STOPS   typeTP=LEVEL;
   double            takeProfit=0;
   ENUM_TYPE_STOPS   typeSL=POINTS;
   double            stopLoss=Stoploss;
   int               magic=Magic;
   string            comment="";
   bool              correctMaxLot=true;
   
   
   int NumberAttempts=5;
   
   double lotStep=SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
   if(lotStep==0.01)lot=NormalizeDouble(lot,2);
   if(lotStep==0.1)lot=NormalizeDouble(lot,1);
   if(lotStep==1)lot=NormalizeDouble(lot,0);
   
   datetime timer=TimeCurrent();
   int attemps=1;
   
   if(!IsTesting()){
      if(!TerminalInfoInteger(TERMINAL_TRADE_ALLOWED)){ 
         if(TimeCurrent()>timerTradeAllowed+180){
            Alert("Check if automated trading is allowed in the terminal settings!");
            timerTradeAllowed=TimeCurrent();
         }
         return(-1);
      }
      else{ 
         if(!MQLInfoInteger(MQL_TRADE_ALLOWED)){ 
            if(TimeCurrent()>timerTradeAllowed+180){
               Alert("Automated trading is forbidden in the program settings for ",__FILE__); 
               timerTradeAllowed=TimeCurrent();
            } 
            return(-1);
         }
      }
   }  
   
   while((IsTradeContextBusy() || !IsTradeAllowed(symbol,TimeCurrent())) &&
          attemps<=NumberAttempts){
      if(TimeCurrent()>timer+10){
         if(IsTradeContextBusy())Print("Trade context is busy !");
         if(!IsTradeAllowed(symbol,TimeCurrent()))Print("Trade is not allowed at this time !");
         timer=TimeCurrent();
      }
      if(attemps==NumberAttempts)return(-1);
      attemps++;
      Sleep(3000);
   }   
   
   comment+=", "+(string)magic;
   int iteratorAttempts=0;
   int ticket=-1;
   
   double maxLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);
      
   struct STR_LOT{double lot; bool opened;};   
   STR_LOT arr_lot[];
   if(lot>maxLot) {
      if(correctMaxLot)lot=maxLot;
      else{
         while(true){
            ArrayResize(arr_lot,ArraySize(arr_lot)+1);
            arr_lot[ArraySize(arr_lot)-1].opened=false;
            if(lot>=maxLot)arr_lot[ArraySize(arr_lot)-1].lot=maxLot;
            else arr_lot[ArraySize(arr_lot)-1].lot=lot;
            lot-=maxLot;
            if(lot>0)continue;
            break;
         }
      }
   }   
   
   if(lot<SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN))
      lot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
   double point=MarketInfo(symbol,MODE_POINT);
   int digits=(int)MarketInfo(symbol,MODE_DIGITS);
   double minLevel=((double)MarketInfo(symbol,MODE_STOPLEVEL))*point;
   double ask=MarketInfo(symbol,MODE_ASK);
   double bid=MarketInfo(symbol,MODE_BID);
   int slippage=(int)((ask-bid)/point);
   if(OrdersTotal()<(int)AccountInfoInteger(ACCOUNT_LIMIT_ORDERS)||AccountInfoInteger(ACCOUNT_LIMIT_ORDERS)==0){   
      while(true && iteratorAttempts<NumberAttempts){
         iteratorAttempts++;
         if(type==OP_BUY || type==OP_BUYLIMIT || type==OP_BUYSTOP){
            if(!IsTesting())RefreshRates();
            if(AccountFreeMarginCheck(symbol,OP_BUY,lot)<=0 || GetLastError()==134){
               Print("Not enough money: "+symbol+" "+DoubleToString(lot,2)+" lots !!!");
               break;
            }
            if(type==OP_BUY)priceOpen=ask;
            if (type==OP_BUYSTOP && ask>priceOpen-minLevel)
               priceOpen=ask+minLevel+((double)slippage)*point;
            if (type==OP_BUYLIMIT && ask<priceOpen+minLevel)
               priceOpen=ask-minLevel-((double)slippage)*point;
            
            double tp=takeProfit;
            if(typeTP==POINTS)tp=0;
            if (tp !=0 && tp<priceOpen+minLevel)
               tp=priceOpen+minLevel+((double)slippage)*point;
            
            double sl=stopLoss;
            if(typeSL==POINTS)sl=0;
            if (sl !=0 && sl>priceOpen-minLevel)
               sl=priceOpen-minLevel-((double)slippage)*point;
            
            priceOpen=CorrectPriceByMinStep(symbol,priceOpen,true);
            stopLoss=CorrectPriceByMinStep(symbol,stopLoss,true);
            takeProfit=CorrectPriceByMinStep(symbol,takeProfit,true);
            
            if(ArraySize(arr_lot)>0){
               int iteratorOrd=0;
               for(int k=0; k<ArraySize(arr_lot); k++){
                  if(!arr_lot[k].opened){
                     lot = arr_lot[k].lot; 
                     ticket=OrderSend(symbol,type,lot,priceOpen,slippage,sl,tp,comment,magic,0,clrBlue);
                     if(ticket>0){
                        if(typeTP==POINTS || typeSL==POINTS)
                           SetTPSL(symbol,ticket,type,magic,"",typeTP,takeProfit,typeSL,stopLoss,true);
                        iteratorOrd++;
                        arr_lot[k].opened=true;
                        continue;
                     }
                     if(Fun_Error(GetLastError())==1)continue;
                     return(-1);
                  }
               }
               if(iteratorOrd==ArraySize(arr_lot))break;
            } 
            else{
               ticket=OrderSend(symbol,type,lot,priceOpen,slippage,sl,tp,comment,magic,0,clrBlue);
               if(ticket>0){
                  if(typeTP==POINTS || typeSL==POINTS)
                     SetTPSL(symbol,ticket,type,magic,"",typeTP,takeProfit,typeSL,stopLoss,true);
                  break;
               }
               if(Fun_Error(GetLastError())==1)continue;
               return(-1);
            }            
         }
         if(type==OP_SELL || type==OP_SELLLIMIT || type==OP_SELLSTOP){
            if(!IsTesting())RefreshRates();
            if(AccountFreeMarginCheck(symbol,OP_SELL,lot)<=0 || GetLastError()==134){
               Print("Not enough money: "+symbol+" "+DoubleToString(lot,2)+" lots !!!");
               break;
            }
            if(type==OP_SELL)priceOpen=bid;
            if (type==OP_SELLSTOP && bid<priceOpen+minLevel)
               priceOpen=bid-minLevel-((double)slippage)*point;
            if (type==OP_SELLLIMIT && bid>priceOpen-minLevel)
               priceOpen=bid+minLevel+((double)slippage)*point;
            
            double tp=takeProfit;
            if(typeTP==POINTS)tp=0;
            if (tp !=0 && tp>priceOpen-minLevel)
               tp=priceOpen-minLevel-((double)slippage)*point;
            
            double sl=stopLoss;
            if(typeSL==POINTS)sl=0;
            if (sl !=0 && sl<priceOpen+minLevel)
               sl=priceOpen+minLevel+((double)slippage)*point;
                           
            priceOpen=CorrectPriceByMinStep(symbol,priceOpen,false);
            stopLoss=CorrectPriceByMinStep(symbol,stopLoss,false);
            takeProfit=CorrectPriceByMinStep(symbol,takeProfit,false);
            
            if(ArraySize(arr_lot)>0){
               int iteratorOrd=0;
               for(int k=0; k<ArraySize(arr_lot); k++){
                  if(!arr_lot[k].opened){
                     lot = arr_lot[k].lot; 
                     ticket=OrderSend(symbol,type,lot,priceOpen,slippage,sl,tp,comment,magic,0,clrRed);
                     if(ticket>0){
                        if(typeTP==POINTS || typeSL==POINTS)
                           SetTPSL(symbol,ticket,type,magic,"",typeTP,takeProfit,typeSL,stopLoss,true);
                        iteratorOrd++;
                        arr_lot[k].opened=true;
                        continue;
                     }
                     if(Fun_Error(GetLastError())==1)continue;
                     return(-1);
                  }
               }
               if(iteratorOrd==ArraySize(arr_lot))break;
            } 
            else{
               ticket=OrderSend(symbol,type,lot,priceOpen,slippage,sl,tp,comment,magic,0,clrRed);
               if(ticket>0){
                  if(typeTP==POINTS || typeSL==POINTS)
                     SetTPSL(symbol,ticket,type,magic,"",typeTP,takeProfit,typeSL,stopLoss,true);
                  break;
               }
               if(Fun_Error(GetLastError())==1)continue;
               return(-1);
            }                   
         }
      }
   }
   return(ticket);
}
double  CorrectPriceByMinStep(string symbol,
                              double price,
                              bool roundUp){
   if(price==0)return(0);
   double value=price;
   double minStep=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE);
   double point=SymbolInfoDouble(symbol, SYMBOL_POINT);
   int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   
   if(roundUp)value=MathCeil(price/minStep)*minStep;
   else value=MathFloor(price/minStep)*minStep;

   return(NormalizeDouble(value,digits));   
}

//--------------------------------------------------------------------+
//      Close orders                                                  |
//--------------------------------------------------------------------+
bool CloseOrder(const   string           symbol   = "EURUSD",
                const   int              ticket   = -1,
                const   ENUM_ORDER_TYPE  type     = -1,
                const   double           lot      = -1,
                const   int              magic    = -1,
                const   string           comment  = ""){ 
   
   int NumberAttempts=5;
   int iteratorAttempts=0;
   
   datetime timer=TimeCurrent();
   int attemps=1;
   while((IsTradeContextBusy() || (!IsTradeAllowed(symbol,TimeCurrent()) && symbol!="")) &&
          attemps<=NumberAttempts){
      if(TimeCurrent()>timer+10){
         if(IsTradeContextBusy())Print("Trade context is busy !");
         if(!IsTradeAllowed(symbol,TimeCurrent())&& symbol!="")Print("Trade is not allowed at this time !");
         timer=TimeCurrent();
      }
      if(attemps==NumberAttempts)return(true);
      attemps++;
      Sleep(3000);
   }      
   bool clos=false;
   
   int total=OrdersTotal();
   for(int i=total-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         
         string            ord_comm   =OrderComment();
         string            ord_sym    =OrderSymbol();
         ENUM_ORDER_TYPE   ord_type   =(ENUM_ORDER_TYPE)OrderType();
         int               ord_magic  =OrderMagicNumber();
         int               ord_ticket =OrderTicket();
         double            ord_lot    =OrderLots();
         
         double lotClose=lot;
         if(lot==-1 || lot>ord_lot)lotClose=ord_lot;
         
         double point   =MarketInfo(symbol,MODE_POINT);
         double ask     =MarketInfo(symbol,MODE_ASK);
         double bid     =MarketInfo(symbol,MODE_BID);
         int    slippage=(int)((ask-bid)/point);
         
         if((ord_magic ==magic  || magic ==-1) && 
            (ord_sym   ==symbol || symbol=="") && 
            (ord_type  ==type   || type  ==-1) &&
            (ord_ticket==ticket || ticket==-1) &&
            (ord_type  ==type   || type  ==-1) &&
            (StringFind(ord_comm,comment,0) !=-1 || comment=="")){
            if(ord_type==OP_BUY){
               while(true && iteratorAttempts<NumberAttempts){
                  if(!IsTesting())RefreshRates();
                  clos=OrderClose(ord_ticket,lotClose,bid,slippage,clrNONE);
                  if(clos==true) break;
                  iteratorAttempts++;
                  if(Fun_Error(GetLastError())==1)continue;
                  return(false);
               }
            }
            
            if(ord_type==OP_SELL){
               while(true && iteratorAttempts<NumberAttempts){
                  if(!IsTesting())RefreshRates();
                  clos=OrderClose(ord_ticket,lotClose,ask,slippage,clrNONE);
                  if(clos==true)break;
                  iteratorAttempts++;
                  if(Fun_Error(GetLastError())==1)continue;
                  return(false);
               }
            }
            
            if(ord_type==OP_BUYLIMIT || ord_type==OP_BUYSTOP || 
               ord_type==OP_SELLLIMIT || ord_type==OP_SELLSTOP){
               while(true && iteratorAttempts<NumberAttempts){
                  if(OrderDelete(ord_ticket,clrNONE))break;
                  else{ 
                     iteratorAttempts++;
                     if(Fun_Error(GetLastError())==1)continue;
                     return(false);
                  }
               }            
            }
         }          
      }
   }
   return(true);
}
//--------------------------------------------------------------------+
//      Error Processing Function                                     |
//--------------------------------------------------------------------+
int Fun_Error(int Error){  //function checks errors during opening or closing orders  
   switch(Error){
      case  4: Print("Trade server is busy. Trying once again..");
         Sleep(3000);
         return(1);
      case 135:Print("Price changed. Trying once again..");
         RefreshRates();
         return(1);
      case 136:Print("No prices. Waiting for a new tick..");
         while(RefreshRates()==false)
            Sleep(1);
         return(1);
      case 137:Print("Broker is busy. Trying once again..");
         Sleep(3000);
         return(1);
      case 146:Print("Trading subsystem is busy. Trying once again..");
         Sleep(1000);
         return(1);
      case  2: Print("Common error.");
         return(0);
      case  5: Print("Old terminal version.");
         return(1);
      case 64: Print("Account blocked.");
         return(1);
      case 133:Print("Trading forbidden.");
         return(0);
      case 134:Print("Not enough money to execute operation.");
         return(0);
      default: Print("Error occurred: ",Error);
         return(0);
   }
}
//+------------------------------------------------------------------+
//|            Modification Take Profit and Stop Loss                |
//+------------------------------------------------------------------+
//enum ENUM_TYPE_STOPS{POINTS, LEVEL, PERCENT_STOP};

bool SetTPSL (string            symbol   = "EURUSD"   ,  //symbol
              int               ticket   = 123456789  ,  //ticket
              ENUM_ORDER_TYPE   type     = -1         ,  //order type
              int               magic    = -1         ,  //magic
              string            comment  = ""         ,  //comment
              ENUM_TYPE_STOPS   typeTP   = POINTS     ,  //type TP
              double            TP       = 100        ,  //TP
              ENUM_TYPE_STOPS   typeSL   = POINTS     ,  //type SL
              double            SL       = 150        ,  //SL
              bool              correct  = true){        //correct TP, SL if minimum levels is wrong  

   if(TP==-1 && SL==-1) return(false);
   
   int total=OrdersTotal();
   for(int i=total-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         
         int               ord_ticket  =OrderTicket();
         string            ord_symbol  =OrderSymbol();
         int               ord_magic   =OrderMagicNumber();
         string            ord_comment =OrderComment();
         ENUM_ORDER_TYPE   ord_type    =(ENUM_ORDER_TYPE)OrderType();
         double            ord_price   =OrderOpenPrice();
         double            ord_tp      =OrderTakeProfit();
         double            ord_sl      =OrderStopLoss();
         
         if((ord_ticket   ==ticket || ticket<=0) &&
            (ord_symbol   ==symbol || symbol=="") &&
            (ord_type     ==type   || type  ==-1) &&
            (ord_magic    ==magic  || magic ==-1) &&
            (StringFind(ord_comment,comment,0) !=-1 || comment=="")){
            
            double newTP=TP;
            double newSL=SL;
            
            double point=SymbolInfoDouble(ord_symbol,SYMBOL_POINT);
            double minLevel=(double)SymbolInfoInteger(ord_symbol,SYMBOL_TRADE_STOPS_LEVEL)*point;
            
            if(ord_tp>0 && TP==-1)newTP=ord_tp;
            if(ord_sl>0 && SL==-1)newSL=ord_sl;
            if(ord_tp==0 && TP==0 && ord_sl==0 && SL==0)return(false);
            
            if(ord_type==ORDER_TYPE_BUY || ord_type==ORDER_TYPE_BUY_STOP || ord_type==ORDER_TYPE_BUY_LIMIT){
            
               bool printError=false;
               string message=""; 
               
               if((typeTP==POINTS || typeTP==PERCENT_STOP) && TP>0){
                  if(typeTP==POINTS) newTP=ord_price+TP*point;
                  if(typeTP==PERCENT_STOP) newTP=ord_price*(1+TP/100);
                  if(newTP<ord_price+minLevel && newTP !=0){
                     if(correct)newTP=ord_price+minLevel;
                     else{
                        printError=true;
                        message+="TP is wrong: "+(string)newTP;
                     } 
                  }          
               }
               if((typeSL==POINTS || typeSL==PERCENT_STOP) && SL>0){
                  if(typeSL==POINTS) newSL=ord_price-SL*point;
                  if(typeSL==PERCENT_STOP) newSL=ord_price*(1-SL/100);
                  if(newSL>ord_price-minLevel && newSL !=0){
                     if(correct)newSL=ord_price-minLevel;
                     else{
                        printError=true;
                        message+="SL is wrong: "+(string)newSL;
                     }          
                  }
               } 
               if(!correct && printError){
                  Print(message);
                  return(false);
               }
               newSL=CorrectPriceByMinStep(symbol,newSL,true); 
               newTP=CorrectPriceByMinStep(symbol,newTP,true);  
            }
            if(ord_type==ORDER_TYPE_SELL || ord_type==ORDER_TYPE_SELL_STOP || ord_type==ORDER_TYPE_SELL_LIMIT){
            
               bool printError=false;
               string message=""; 
            
               if((typeTP==POINTS || typeTP==PERCENT_STOP) && TP>0){
                  if(typeTP==POINTS) newTP=ord_price-TP*point;
                  if(typeTP==PERCENT_STOP) newTP=ord_price*(1-TP/100);
                  if(newTP>ord_price-minLevel && newTP !=0){
                     if(correct)newTP=ord_price-minLevel;
                     else{
                        printError=true;
                        message+="TP is wrong: "+(string)newTP;
                     }          
                  }
               }
               if((typeSL==POINTS || typeSL==PERCENT_STOP) && SL>0){
                  if(typeSL==POINTS) newSL=ord_price+SL*point;
                  if(typeSL==PERCENT_STOP) newSL=ord_price*(1+SL/100);
                  if(newSL<ord_price+minLevel && newSL !=0){
                     if(correct)newSL=ord_price+minLevel;
                     else{
                        printError=true;
                        message+="SL is wrong: "+(string)newSL;
                     }                 
                  }
               } 
               newSL=CorrectPriceByMinStep(symbol,newSL,false); 
               newTP=CorrectPriceByMinStep(symbol,newTP,false);  
            }
            if(TP==0)newTP=0;
            if(SL==0)newSL=0;
            
            ResetLastError();
            if(!OrderModify(ord_ticket,ord_price,newSL,newTP,0,clrNONE))
               Print(__FUNCTION__," ",GetLastError());           
         }
      }
   }   
   return(true);   
}
//--------------------------------------------------------------------+
//      Create RECTANGLE_LABEL                                        |
//--------------------------------------------------------------------+
void RectLabelCreate(const string           name="RectLabel",  
                     const int              width=50,              
                     const int              height=18) {               
   
   if(name=="MOVE"){
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,clrDimGray); 
   }
   
   if(ObjectFind(0,name)!=-1){
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width); 
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height); 
   }
   
   if(ObjectFind(0,name)==-1){
      ResetLastError(); 
      if(!ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,0,0,0)) 
        { 
         Print(__FUNCTION__," ",GetLastError()); 
         return; 
        } 
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,Xdist); 
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,Ydist); 
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width); 
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height); 
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,PanelColor); 
      ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_SUNKEN); 
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER); 
      ObjectSetInteger(0,name,OBJPROP_COLOR,PanelColor); 
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID); 
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1); 
      ObjectSetInteger(0,name,OBJPROP_BACK,false); 
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false); 
      ObjectSetInteger(0,name,OBJPROP_SELECTED,false); 
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true); 
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0); 
   }
}   
//--------------------------------------------------------------------+
//      Create BUTTON                                                 |
//--------------------------------------------------------------------+
bool ButtonCreate(const string            name="Button",
                  const int               x=0,                   
                  const int               y=0,               
                  const int               width=50,             
                  const int               height=18,           
                  const string            text="Button"){   
                  
   string font="Arial";
   int font_size=10;
   color clr=clrBlack;
   color back_clr=C'236,233,216';
   color border_clr=clrNONE;
 
   if(ObjectFind(0,name)!=-1){
      ObjectSetString(0,name,OBJPROP_TEXT,text); 
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x); 
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y); 
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width); 
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height); 
   }
   
   if(ObjectFind(0,name)==-1){
      ResetLastError(); 
      if(!ObjectCreate(0,name,OBJ_BUTTON,0,0,0)){ 
         Print(__FUNCTION__," ",GetLastError()); 
         return(false); 
      } 
   
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x); 
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y); 
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width); 
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height); 
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER); 
      ObjectSetString(0,name,OBJPROP_TEXT,text); 
      ObjectSetString(0,name,OBJPROP_FONT,font); 
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,font_size); 
      ObjectSetInteger(0,name,OBJPROP_COLOR,clr); 
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,back_clr); 
      ObjectSetInteger(0,name,OBJPROP_BORDER_COLOR,border_clr); 
      ObjectSetInteger(0,name,OBJPROP_BACK,false); 
      ObjectSetInteger(0,name,OBJPROP_STATE,false); 
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false); 
      ObjectSetInteger(0,name,OBJPROP_SELECTED,false); 
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,false); 
      ObjectSetInteger(0,name,OBJPROP_ZORDER,5); 
   }
   return(true); 
} 
//--------------------------------------------------------------------+
//        Label Create                                                |
//--------------------------------------------------------------------+
void LabelCreate(const string            name="Label",           
                 const string            text="Label",        
                 const int               y=0){ 
   
   if (ObjectFind(0,name)!=-1){
      ObjectSetString(0,name,OBJPROP_TEXT,text); 
      ObjectSetInteger(0,name,OBJPROP_COLOR,TextColor); 
   }
   if (ObjectFind(0,name)==-1){
      ObjectCreate(0,name,OBJ_LABEL,0,0,0); 
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,Xdist+5); 
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y); 
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER); 
      ObjectSetString(0,name,OBJPROP_TEXT,text); 
      ObjectSetString(0,name,OBJPROP_FONT,"Courier New"); 
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,FontSize); 
      ObjectSetDouble(0,name,OBJPROP_ANGLE,0); 
      ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER); 
      ObjectSetInteger(0,name,OBJPROP_COLOR,TextColor); 
      ObjectSetInteger(0,name,OBJPROP_BACK,false); 
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false); 
      ObjectSetInteger(0,name,OBJPROP_SELECTED,false); 
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true); 
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0); 
   }
} 
//--------------------------------------------------------------------+
//      Add profit to structure of symbols                            |
//--------------------------------------------------------------------+
void InputsAddProfit(string symbol, double profit, double loss, bool reset){
   for(int i=0; i<ArraySize(inputs); i++){  
      if(reset){
         inputs[i].profit=0;
         inputs[i].loss=0;
      }
      else{
         if(inputs[i].symbol==symbol){
            inputs[i].profit+=profit;
            inputs[i].loss+=loss;
         }
      }
   }
}

//--------------------------------------------------------------------+
//      Statistics                                                    |
//--------------------------------------------------------------------+
void Statistics(  int& totalTrades, 
                  int& profitTrades, 
                  int& openTrades,
                  double& openLots,
                  string& bestSymbol,
                  double& bestSymbolProfit,
                  double& bestSymbolLoss,
                  string& worstSymbol,
                  double& worstSymbolProfit,
                  double& worstSymbolLoss,
                  double& equity,
                  double& growthPerc,
                  double& ddPercCurr,
                  double& ddPercMax){

   InputsAddProfit("",0,0,true);
   double depo=0;
   double totalProfit=0;
   double totalLoss=0;
   
   int total=OrdersHistoryTotal();
   for(int i=total-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         
         string            ord_symbol     = OrderSymbol();
         int               ord_magic      = OrderMagicNumber();
         double            ord_profit     = OrderProfit();
         double            ord_commiss    = OrderCommission();
         double            ord_swap       = OrderSwap(); 
         ENUM_ORDER_TYPE   ord_type       = (ENUM_ORDER_TYPE)OrderType();
         
         if((int)ord_type < 0 || (int)ord_type > 5){
            depo+=ord_profit;
         }
         
         if(ord_magic==Magic){
            double profit=ord_profit+ord_commiss+ord_swap;
            totalProfit+=profit;
            if(profit>0)InputsAddProfit(ord_symbol,profit,0,false);
            else InputsAddProfit(ord_symbol,0,profit,false);
            
            totalTrades++;
            if(profit>0) profitTrades++;
         }
      }
   }
   
   total=OrdersTotal();
   for(int i=total-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         
         string            ord_symbol     = OrderSymbol();
         int               ord_magic      = OrderMagicNumber();
         double            ord_lots       = OrderLots();
         double            ord_profit     = OrderProfit();
         double            ord_commiss    = OrderCommission();
         double            ord_swap       = OrderSwap(); 
         
         if(ord_magic==Magic){
            ddPercCurr+=ord_profit+ord_commiss+ord_swap;
            openTrades++;
            openLots+=ord_lots;
         }
      }
   }
   double balance=AccountBalance();
   equity=AccountEquity();
   
   ddPercCurr=ddPercCurr/balance*100;
   if(ddPercCurr>GlobalVariableGet(nameGVmaxDD))GlobalVariableSet(nameGVmaxDD,ddPercCurr);
   ddPercMax=GlobalVariableGet(nameGVmaxDD);
   if(depo==0)depo=AccountBalance();
   growthPerc=totalProfit/depo*100;
   
   for(int i=0; i<ArraySize(inputs); i++){
      if(inputs[i].profit+inputs[i].loss>bestSymbolProfit+bestSymbolLoss || bestSymbol==""){
         bestSymbol=inputs[i].symbol;
         bestSymbolProfit=inputs[i].profit;
         bestSymbolLoss=inputs[i].loss;
      }
      if(inputs[i].profit+inputs[i].loss<worstSymbolProfit+worstSymbolLoss || worstSymbol==""){
         worstSymbol=inputs[i].symbol;
         worstSymbolProfit=inputs[i].profit;
         worstSymbolLoss=inputs[i].loss;
      }   
   }
   
}

//+------------------------------------------------------------------+
//|                          Panel                                   |
//+------------------------------------------------------------------+
void Panel(){
   if(!PanelShow)return;
   
   static datetime lastCalc=0;
   datetime timeCurr=TimeCurrent();
   if(timeCurr<lastCalc+5)return;
   
   lastCalc=timeCurr;
   
   int totalTrades=0; 
   int profitTrades=0; 
   int openTrades=0;
   double openLots=0;
   string bestSymbol="";
   double bestSymbolProfit=0;
   double bestSymbolLoss=0;
   string worstSymbol="";
   double worstSymbolProfit=0;
   double worstSymbolLoss=0;
   double equity=0;
   double growthPerc=0;
   double ddPercCurr=0;
   double ddPercMax=0;   
   
   Statistics(
      totalTrades,
      profitTrades,
      openTrades,
      openLots,
      bestSymbol,
      bestSymbolProfit,
      bestSymbolLoss,
      worstSymbol,
      worstSymbolProfit,
      worstSymbolLoss,
      equity,
      growthPerc,
      ddPercCurr,
      ddPercMax);
   
   string curr=AccountCurrency();
   
   string text[];
   ArrayResize(text,14);
   
   text[0] ="Total Trades        : "+(string)totalTrades;
   text[1] ="Profitable Trades   : "+(string)profitTrades;
   text[2] ="Open Trades         : "+(string)openTrades;
   text[3] ="Open Lots           : "+DoubleToStr(openLots,2);
   text[4] ="Best Symbol         : "+bestSymbol;
   text[5] ="Best Symbol Profit  : "+DoubleToStr(bestSymbolProfit,2)+" "+curr;
   text[6] ="Best Symbol Loss    : "+DoubleToStr(bestSymbolLoss,2)+" "+curr;
   text[7] ="Worst Symbol        : "+worstSymbol;
   text[8] ="Worst Symbol Profit : "+DoubleToStr(worstSymbolProfit,2)+" "+curr;
   text[9] ="Worst Symbol Loss   : "+DoubleToStr(worstSymbolLoss,2)+" "+curr;
   text[10]="Equity              : "+DoubleToStr(equity,2)+" "+curr;
   text[11]="Growth Perc         : "+DoubleToStr(growthPerc,1)+"%";
   text[12]="Drawdown Current    : "+DoubleToStr(ddPercCurr,1)+"%";
   text[13]="Drawdown Maximum    : "+DoubleToStr(ddPercMax,1)+"%";   

   string textShort[];
   ArrayResize(textShort,14);
   textShort[0] ="TT "+(string)totalTrades+"; ";
   textShort[1] ="PT "+(string)profitTrades+"; ";
   textShort[2] ="OT "+(string)openTrades+"; ";
   textShort[3] ="OL "+DoubleToStr(openLots,2)+"; ";
   textShort[4] ="BS "+bestSymbol+"; ";
   textShort[5] ="BSP "+DoubleToStr(bestSymbolProfit,2)+"; ";
   textShort[6] ="BSL "+DoubleToStr(bestSymbolLoss,2)+"; ";
   textShort[7] ="WS "+worstSymbol+"; ";
   textShort[8] ="WSP "+DoubleToStr(worstSymbolProfit,2)+"; ";
   textShort[9] ="WSL "+DoubleToStr(worstSymbolLoss,2)+"; ";
   textShort[10]="E "+DoubleToStr(equity,2)+"; ";
   textShort[11]="GP "+DoubleToStr(growthPerc,1)+"%; ";
   textShort[12]="DD C "+DoubleToStr(ddPercCurr,1)+"%; ";
   textShort[13]="DD M "+DoubleToStr(ddPercMax,1)+"%; ";   

   int len= MathMax(StringLen(text[0]),
            MathMax(StringLen(text[1]),
            MathMax(StringLen(text[2]),
            MathMax(StringLen(text[3]),
            MathMax(StringLen(text[4]),
            MathMax(StringLen(text[5]),
            MathMax(StringLen(text[6]),
            MathMax(StringLen(text[7]),
            MathMax(StringLen(text[8]),
            MathMax(StringLen(text[9]),
            MathMax(StringLen(text[10]),
            MathMax(StringLen(text[11]),
            MathMax(StringLen(text[12]),
                    StringLen(text[13]))))))))))))));
                    
   RectLabelCreate(NameEA+"RectLab",FontSize*(int)(len*0.9)+10,(FontSize+5)*14+10+30);
   
   string textAll="";
   
   for(int i=0; i<14; i++){
      LabelCreate(NameEA+"lab"+(string)i,text[i],5+Ydist+i*(FontSize+5));
      textAll+=textShort[i];
   }
   
   if(timeCurr>lastMess+PushNotifications*3600){
      lastMess=timeCurr;
      Messenger(textAll,Alert_chart,Alert_email,Alert_push,Alert_sound,Sounds(Sound));
   }
   
   ButtonCreate(NameEA+"butClose",Xdist+5,10+Ydist+14*(FontSize+5),120,25,"Close all positions");
}
//--------------------------------------------------------------------+
//                      Return name of sound file                     |
//--------------------------------------------------------------------+
string Sounds(ENUM_SOUNDS sound){
   if(sound==SOUND_ALERT)     return("alert.wav");
   if(sound==SOUND_ALERT2)    return("alert2.wav");
   if(sound==SOUND_CONNECT)   return("connect.wav");
   if(sound==SOUND_DISCONNECT)return("disconnect.wav");
   if(sound==SOUND_EXPERT)    return("expert.wav");
   if(sound==SOUND_NEWS)      return("news.wav");
   if(sound==SOUND_OK)        return("ok.wav");
   if(sound==SOUND_STOPS)     return("stops.wav");
   if(sound==SOUND_TICK)      return("tick.wav");
   if(sound==SOUND_TIMEOUT)   return("timeout.wav");
   if(sound==SOUND_WAIT)      return("wait.wav");
   return("alert.wav");
}
//--------------------------------------------------------------------+
//                      Prefix and Suffix                             |
//--------------------------------------------------------------------+
void PrefSuff(string& prefix, string& suffix){
   int total=SymbolsTotal(false);
   for(int i=0; i<total; i++){
      string name=SymbolName(i,false);
      if(StringFind(name,"EURUSD",0)!=-1){
         if(StringFind(name,"EURUSD",0)>0){
            prefix=StringSubstr(name,0,StringFind(name,"EURUSD",0));
         }
         if(StringFind(name,"EURUSD",0)+6<StringLen(name)){
            suffix=StringSubstr(name,StringFind(name,"EURUSD",0)+6);
         }
         return;
      }   
   }
}